/*====================================================================================
 	Arvi's Waveform Sonique Visual Plugin API
        (c) 2000 Arvinder Sehmi (Arvinder@Sehmi.org.uk)
====================================================================================*/
#include <windows.h>
#include "vis.h"
void initialize(void);
BOOL render(unsigned long* Video, int width, int height, int pitch, VisData* pVD);
BOOL savesettings(char* FileName);
BOOL opensettings(char* FileName);
unsigned long MakeColor(int Red, int Green, int Blue);
BOOL WaveVis1(unsigned long* Video, int width, int height, int pitch, VisData* pVD);
BOOL WaveVis2(unsigned long* Video, int width, int height, int pitch, VisData* pVD);
BOOL WaveVis3(unsigned long* Video, int width, int height, int pitch, VisData* pVD);
BOOL WaveVisX(unsigned long* Video, int width, int height, int pitch, VisData* pVD, int r1,int g1,int b1, int r2,int g2, int b2);
void InitWaveVis1(void);
void InitWaveVis2(void);
void InitWaveVis3(void);
void InitWaveVisX(void);
double r=255, g=0, b=0, c=1;
int rdec=0, gdec=0, bdec=0;
int rinc=0, ginc=1, binc=0;
int initwidth=0;
int rs=1, gs=2, bs=3;
int t=0;

VisInfo plugin={NULL,"Arvi's Waveform Plugin",VI_WAVEFORM|SONIQUEVISPROC,
				&initialize,&render,&savesettings,&opensettings};

DLLEXPORT VisInfo* QueryModule(void){return &plugin;}
void initialize(void){}

BOOL render(unsigned long* Video, int width, int height, int pitch, VisData* pVD)
{
	t++;

	if (t==1)			InitWaveVis1();
	if (t>0   && t<200)	WaveVis1(Video, width, height, pitch, pVD); 
	
	if (t==201)			InitWaveVisX();
	if (t>200 && t<300) WaveVisX(Video, width, height, pitch, pVD, 400,400,80,80,400,80); 
		
	if (t==301)			InitWaveVis2();
	if (t>300 && t<500) WaveVis2(Video, width, height, pitch, pVD); 
	
	if (t==501)			InitWaveVisX();
	if (t>500 && t<700) WaveVisX(Video, width, height, pitch, pVD, 260,260,260, 0,200,400); 
	
	if (t==701)			InitWaveVis3();
	if (t>700 && t<900) WaveVis3(Video, width, height, pitch, pVD); 
	
	if (t==900) t=0;

	return TRUE;
}

BOOL WaveVis1(unsigned long* Video, int width, int height, int pitch, VisData* pVD)
{
	int x, y, seccol, d, firstcol;
    if ((initwidth!=width)||(initwidth==0)) {initwidth=width;c=1;}

	for(x = 0; x < width; x ++)
	{ 
		d=(width/width*2);
		
		r=(x*(d*6))/c;	g=(x*(d*3))/c;	b=(x*(d*1))/c;
		
		if (r>255 && g>255 && b>255) c+=0.01;

		y = ((height/2) - pVD->Waveform[0][x&255]);
		if(y < 2) y = height/2; 	
	
	firstcol = MakeColor((int)r,(int)g,(int)b);
	seccol=    MakeColor((int)r-80,(int)g-80,(int)b-80);

check1: if (y>height) {y-=1; goto check1;}
		if (y<0) {y++; goto check1;}
		Video[y*pitch + x] = firstcol;
		Video[(y+1)*pitch + x] = seccol;Video[(y-1)*pitch + x] = seccol;	
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		
		y = ((height/2) + pVD->Waveform[1][x&255]);
		if(y > (height-3)) y = height/2;

	firstcol = MakeColor((int)b,(int)g,(int)r);
	seccol=    MakeColor((int)b-80,(int)g-80,(int)r-80);
	
check2: if (y>height) {y-=1; goto check2;}
		if (y<0) {y++; goto check2;}
		Video[y*pitch + x] = firstcol;		
		Video[(y+1)*pitch + x] = seccol;Video[(y-1)*pitch + x] = seccol;
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
	}
	return TRUE;
}

BOOL WaveVis2(unsigned long* Video, int width, int height, int pitch, VisData* pVD)
{
	int x, y, seccol;

	for(x = 0; x < width; x ++)
	{
	   
	if(rinc==1){r=r+0.05; if(r>255){bdec=1;rinc=0;}}
	if(ginc==1){g=g+0.05; if(g>255){rdec=1;ginc=0;}}
	if(binc==1){b=b+0.05; if(b>255){gdec=1;binc=0;}}
	
	if(rdec==1){r=r-0.05; if(r<0){rdec=0;binc=1;}}
	if(gdec==1){g=g-0.05; if(g<0){rinc=1;gdec=0;}}
	if(bdec==1){b=b-0.05; if(b<0){ginc=1;bdec=0;}}
	
		y = ((height/2) - pVD->Waveform[0][x&255]);
		if(y < 2) y = height/2; 

check1: if (y>height) {y-=1; goto check1;}
		if (y<0) {y++; goto check1;}

		Video[y*pitch + x] = MakeColor((int)r,(int)g,(int)b);	
		seccol=MakeColor((int)r-80,(int)g-80,(int)b-80);
		Video[(y+1)*pitch + x] = seccol;Video[(y-1)*pitch + x] = seccol;	
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		
		y = ((height/2) + pVD->Waveform[1][x&255]);
		if(y > (height-3)) y = height/2;

check2: if (y>height) {y-=1; goto check2;}
		if (y<0) {y++; goto check2;}

		Video[y*pitch + x] = MakeColor((int)b,(int)r,(int)g);		
		seccol=MakeColor((int)b-80,(int)r-80,(int)g-80);
		Video[(y+1)*pitch + x] = seccol;Video[(y-1)*pitch + x] = seccol;
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
	}
    
	return TRUE;
}

BOOL WaveVis3(unsigned long* Video, int width, int height, int pitch, VisData* pVD)
{
	int x, y, seccol;
	r=r+rs;	if (r>255) rs=-rs;	if (r<80) rs=-rs;
	g=g+gs;	if (g>255) gs=-gs;	if (g<80) gs=-gs;
	b=b+bs;	if (b>255) bs=-bs;	if (b<80) bs=-bs;
	
	for(x = 0; x < width; x ++)
	{
		y = ((height/2) - pVD->Waveform[0][x&255]);
		if(y < 2) y = height/2; 
		
check1: if (y>height) {y-=1; goto check1;}
		if (y<0) {y++; goto check1;}

		Video[y*pitch + x] = MakeColor((int)r,(int)g,(int)b);	
		seccol=MakeColor((int)r-80,(int)g-80,(int)b-80);
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		Video[((y+1)*pitch + x)]=seccol;Video[((y-1)*pitch + x)]=seccol;
	
        y = ((height/2) + pVD->Waveform[1][x&255]);
		if(y > (height-1)) y = height/2; 

check2: if (y>height) {y-=1; goto check2;}
		if (y<0) {y++; goto check2;}

		Video[y*pitch + x] = MakeColor((int)g,(int)b,(int)r);
		seccol=MakeColor((int)g-80,(int)b-80,(int)r-80);
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		Video[((y+1)*pitch + x)]=seccol;Video[((y-1)*pitch + x)]=seccol;
	}
    return TRUE;
}

BOOL WaveVisX(unsigned long* Video, int width, int height, int pitch, VisData* pVD, int r1,int g1,int b1, int r2,int g2, int b2)
{
	int x, y, seccol;
	
	for(x = 0; x < width; x ++)
	{
		y = ((height/2) - pVD->Waveform[0][x&255]);
		if(y < 2) y = height/2; 

check1: if (y>height) {y-=1; goto check1;}
		if (y<0) {y++; goto check1;}

		Video[y*pitch + x] = MakeColor(r1,g1,b1);
		seccol=MakeColor(r1-80,g1-80,b1-80);
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		Video[((y+1)*pitch + x)]=seccol;Video[((y-1)*pitch + x)]=seccol;
	
        y = ((height/2) + pVD->Waveform[1][x&255]);
		if(y > (height-1)) y = height/2; 

check2: if (y>height) {y-=1; goto check2;}
		if (y<0) {y++; goto check2;}
		
		Video[y*pitch + x] = MakeColor(r2,g2,b2);
		seccol=MakeColor(r2-80,g2-80,b2-80);
		Video[(y*pitch + x)+1] = seccol;Video[(y*pitch + x)-1] = seccol;
		Video[((y+1)*pitch + x)]=seccol;Video[((y-1)*pitch + x)]=seccol;
	}
    return TRUE;
}

void InitWaveVis1(void){r=0;g=0;b=0;c=1;rdec=0;gdec=0;bdec=0;rinc=0;ginc=1;binc=0;initwidth=0;}
void InitWaveVis2(void){r=255;g=0;b=0;rdec=0;gdec=0;bdec=0;rinc=0;ginc=1;binc=0;}
void InitWaveVis3(void){r=255;g=255;b=255;rs=1;gs=2;bs=3;}
void InitWaveVisX(void){InitWaveVis2();}

unsigned long MakeColor(int Red,int Green,int Blue)
{
    if(Red > 255) Red =255;if(Red<0) Red=0;
    if(Green > 255) Green=255;if(Green<0) Green=0;
    if(Blue > 255) Blue=255;if(Blue<0) Blue=0;
    Red*=65536;Green*=256;
  return(Red+Green+Blue);
}

BOOL savesettings(char* FileName){/*WritePrivateProfileString("plugin","bright","3",File);*/return TRUE;}
BOOL opensettings(char* FileName){/*char BrightBuff[256]; GetPrivateProfileString("plugin","bright","3",BrightBuff,sizeof(BrightBuff),File);*/return TRUE;}
